#include <amxmodx>
#include <fakemeta_util>
#include <cstrike>

#define CONC_WEAP CSW_SCOUT

new scout_push, scout_radius, scout_nofall, scout_fx, scout_iammo;
new lastammo[33];
new lastweap[33];
new g_Explosion;
new NoFallDamage[33];

public plugin_init()
{ 
	register_plugin("Scout Conc", "0.1", "Emp`");
	scout_push = register_cvar("scout_conc","800.0");
	scout_radius = register_cvar("scout_radius","400.0");
	scout_nofall = register_cvar("scout_nofall","1");
	scout_fx = register_cvar("scout_fx","3");
	scout_iammo = register_cvar("scout_iammo","1");
	register_event("CurWeapon","make_tracer", "be", "1=1");
	register_forward(FM_PlayerPreThink,"fw_playerprethink");
	register_forward(FM_PlayerPostThink,"fw_playerpostthink");
} 

public plugin_precache()
{
	g_Explosion = precache_model("sprites/zerogxplode.spr");
}

stock get_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed, Float:fVelocity[3] )
{
	new Float:fEntOrigin[3];
	pev( ent, pev_origin, fEntOrigin );

	// Velocity = Distance / Time

	new Float:fDistance[3];
	fDistance[0] = fEntOrigin[0] - fOrigin[0];
	fDistance[1] = fEntOrigin[1] - fOrigin[1];
	fDistance[2] = fEntOrigin[2] - fOrigin[2];

	new Float:fTime = ( vector_distance( fEntOrigin,fOrigin ) / fSpeed );

	fVelocity[0] = fDistance[0] / fTime;
	fVelocity[1] = fDistance[1] / fTime;
	fVelocity[2] = fDistance[2] / fTime;

	return ( fVelocity[0] && fVelocity[1] && fVelocity[2] );
}


// Sets velocity of an entity (ent) away from origin with speed (speed)

stock set_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed )
{
	new Float:fVelocity[3];
	get_velocity_from_origin( ent, fOrigin, fSpeed, fVelocity )

	set_pev( ent, pev_velocity, fVelocity );

	return ( 1 );
}

public make_tracer(id)
{
	new Float:maxboost = get_pcvar_float(scout_push);
	if( !maxboost )
		return;

	new weap = read_data(2);        // id of the weapon
	new ammo = read_data(3);        // ammo left in clip

	if( weap == CONC_WEAP && is_user_alive(id) ){

		if( lastweap[id] == 0 )
			lastweap[id] = weap;

		if( lastammo[id] > ammo && lastweap[id] == weap ){
			new Vec[3], Float:fVec[3], Float:origin[3];
			get_user_origin(id, Vec, 3);

			IVecFVec(Vec, fVec);

			pev(id, pev_origin, origin);
			new Float:dist = get_distance_f( origin, fVec );
			new Float:radius = get_pcvar_float( scout_radius );
			if(dist <= radius){
				new Float:boost = maxboost - ( ( maxboost * dist) / radius );
				set_velocity_from_origin(id, fVec, boost);
			}

			new fx = get_pcvar_num( scout_fx );

			if( fx & 1 ){
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
				write_byte(TE_EXPLOSION);
				write_coord(Vec[0]);
				write_coord(Vec[1]);
				write_coord(Vec[2]);
				write_short(g_Explosion);
				write_byte(30);
				write_byte(15);
				write_byte(0);
				message_end();
			}

			if( fx & 2 ){
				message_begin( MSG_BROADCAST,SVC_TEMPENTITY);
				write_byte(TE_EXPLOSION2);
				write_coord(Vec[0]);
				write_coord(Vec[1]);
				write_coord(Vec[2]);
				write_byte(188); // start color
				write_byte(10); // num colors
				message_end();
			}

			if( get_pcvar_num( scout_iammo ) ){
				new wpn[32];
				get_weaponname(weap,wpn,31);

				if( ammo == 1 ){
					new iWPNidx = -1;
					while( (iWPNidx = fm_find_ent_by_class(iWPNidx, wpn)) ){
						if( id == pev(iWPNidx, pev_owner) ){
							cs_set_weapon_ammo(iWPNidx, 11);
							ammo = 11;
							break;
						}
					}
				}
			}
		}
		lastammo[id] = ammo;
		lastweap[id] = weap;
	}
}
public fw_playerprethink(id)
{
	NoFallDamage[id] = get_pcvar_num( scout_nofall );
}
public fw_playerpostthink(id)
{
	if( NoFallDamage[id] )
		set_pev(id, pev_watertype, -3);
}


